package com.alihealth.d2d.provtest.domain;

import com.alihealth.d2d.provtest.utils.LocalDateDeserializer;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import java.io.Serializable;
import java.time.LocalDate;
import java.time.LocalDateTime;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import lombok.Getter;
import lombok.Setter;

/**
 * <p>
 * 药品经营许可证基本信息数据子集
 * </p>
 *
 * @author Jason
 * @since 2025-06-06
 */
@Getter
@Setter
@TableName("pharmaceutical_trading_license_base_info")
public class PharmaceuticalTradingLicenseBaseInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 事件流水号
     */
    private String eventId;

    /**
     * 经营许可证编号
     */
    @JacksonXmlProperty(localName = "JYXKZBH")
    private String jyxkzbh;

    /**
     * 企业名称
     */
    @JacksonXmlProperty(localName = "QYMC")
    private String qymc;

    /**
     * 企业类型
     */
    @JacksonXmlProperty(localName = "QYLX")
    private String qylx;

    /**
     * 企业小类
     */
    @JacksonXmlProperty(localName = "QYXL")
    private String qyxl;

    /**
     * 统一社会信用代码
     */
    @JacksonXmlProperty(localName = "TYSHXYDM")
    private String tyshxydm;

    /**
     * 注册地址
     */
    @JacksonXmlProperty(localName = "ZCDZ")
    private String zcdz;

    /**
     * 法定代表人
     */
    @JacksonXmlProperty(localName = "FDDBR")
    private String fddbr;

    /**
     * 企业负责人
     */
    @JacksonXmlProperty(localName = "QYFZR")
    private String qyfzr;

    /**
     * 质量负责人
     */
    @JacksonXmlProperty(localName = "ZLFZR")
    private String zlfzr;

    /**
     * 仓库地址
     */
    @JacksonXmlProperty(localName = "CKDZ")
    private String ckdz;

    /**
     * 经营方式
     */
    @JacksonXmlProperty(localName = "JYFS")
    private String jyfs;

    /**
     * 经营范围
     */
    @JacksonXmlProperty(localName = "JYFW")
    private String jyfw;

    /**
     * 有效期
     */
    @JacksonXmlProperty(localName = "YXQ")
    @JsonDeserialize(using = LocalDateDeserializer.class)
    private LocalDate yxq;

    /**
     * 发证机关
     */
    @JacksonXmlProperty(localName = "FZJG")
    private String fzjg;

    /**
     * 签发人
     */
    @JacksonXmlProperty(localName = "QFR")
    private String qfr;

    /**
     * 签发日期
     */
    @JacksonXmlProperty(localName = "QFRQ")
    @JsonDeserialize(using = LocalDateDeserializer.class)
    private LocalDate qfrq;

    /**
     * 日常监督管理机构
     */
    @JacksonXmlProperty(localName = "RCJDGLJG")
    private String rcjdgljg;

    /**
     * 投诉举报电话
     */
    @JacksonXmlProperty(localName = "TSJBDH")
    private String tsjbdh;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    /**
     * 是否删除(0-否 1-是)
     */
    private Integer isDeleted;


}
