package com.alihealth.d2d.provtest.service.handle.business;

import com.alihealth.d2d.provtest.domain.DrugRetailAndUseApplyInfo;
import com.alihealth.d2d.provtest.entity.EventBasic;
import com.alihealth.d2d.provtest.entity.EventBody;
import com.alihealth.d2d.provtest.entity.InstanceDetail;
import com.alihealth.d2d.provtest.entity.ItemDetail;
import com.alihealth.d2d.provtest.service.IDrugRetailAndUseApplyInfoService;
import com.alihealth.d2d.provtest.service.handle.AbstractEventDataHandler;
import com.alihealth.d2d.provtest.service.handle.EventSubType;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;

@Service
@EventSubType("2017")
public class SubType2017Handler extends AbstractEventDataHandler<DrugRetailAndUseApplyInfo> {

    @Autowired
    private IDrugRetailAndUseApplyInfoService service;

    @Override
    protected Class<DrugRetailAndUseApplyInfo> getEntityClass() {
        return DrugRetailAndUseApplyInfo.class;
    }

    @Override
    protected IService<DrugRetailAndUseApplyInfo> getService() {
        return service;
    }

    @Override
    protected DrugRetailAndUseApplyInfo convertToEntity(EventBody eventBody, ItemDetail item, InstanceDetail instance) {
        EventBasic evtBasic = eventBody.getEvtBasic();
        //时间格式
        SimpleDateFormat formatterDatetime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //日期格式
        SimpleDateFormat formatterDate = new SimpleDateFormat("yyyyMMdd");

        try {
            return DrugRetailAndUseApplyInfo.builder()
                    .eventId(eventBody.getEventID())
                    .recTime(formatterDatetime.parse(eventBody.getRecTime()))

                    .ypzsm(instance.getString("YPZSM"))
                    .bzcj(instance.getString("BZCJ"))
                    .syjbzypzsm(instance.getString("SYJBZYPZSM"))
                    .ymzt(instance.getString(("YMZT")))

                    .tyshxydmjnypscqy(item.getString("TYSHXYDMJNYPSCQY"))
                    .jnypscqymc(item.getString("JNYPSCQYMC"))
                    .jwypscqydm(item.getString("JWYPSCQYDM"))
                    .jwypscqymczw(item.getString("JWYPSCQYMCZW"))
                    .yptymc(item.getString("YPTYMC"))
                    .gjypbsm(item.getString("GJYPBSM"))
                    .yppzwh(item.getString("YPPZWH"))
                    .yppzwhyxq(formatterDate.parse(item.getString("YPPZWHYXQ")))
                    .ymscph(item.getString("YMSCPH"))
                    .scrq(formatterDate.parse(item.getString("SCRQ")))
                    .ypqjzrq(formatterDate.parse(item.getString("YPQJZRQ")))
                    .syrq(formatterDate.parse(item.getString("SYRQ")))
                    .tyshxydmjkymdlqy(item.getString("TYSHXYDMJKYMDLQY"))
                    .jkymdlqymc(item.getString("JKYMDLQYMC"))
                    .sysl(item.getInt("SYSL"))
                    .scsj(formatterDatetime.parse(item.getString("SCSJ")))
                    .gmrsfxx(item.getString("GMRSFXX"))
                    .gmrdhhm(item.getString("GMRDHHM"))
                    .hlwddbz(item.getString("HLWDDBZ"))
                    .jx(item.getString("JX"))
                    .bzgg(item.getString("BZGG"))
                    .zjgg(item.getString("ZJGG"))
                    .bzzhb(new BigDecimal(item.getString("BZZHB")))
                    .bzzhbdw(item.getString("BZZHBDW"))
                    .ypzcfl(item.getString("YPZCFL"))
                    .tsypglfl(item.getString("TSYPGLFL"))

                    .tyshxydmlsyd(evtBasic.getString("TYSHXYDMLSYD"))
                    .zyxkzdjh(evtBasic.getString("ZYXKZDJH"))
                    .lsydmc(evtBasic.getString("LSYDMC"))
                    .sydwlx(evtBasic.getString("SYDWLX"))
                    .sydwlxxl(evtBasic.getString("SYDWLXXL"))
                    .lsdjbh(evtBasic.getString("LSDJBH"))
                    .jyxkzbh(evtBasic.getString("JYXKZBH"))
                    .wsjgdm(evtBasic.getString("WSJGDM"))
                    .kfys(evtBasic.getString("KFYS"))
                    .ypfyr(evtBasic.getString("YPFYR"))
                    .ypsyz(evtBasic.getString("YPSYZ"))
                    .ypsyzdlr(evtBasic.getString("YPSYZDLR"))

                    .build();
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public String getSubType() {
        return "2017";
    }

    @Override
    public void handleBase(String xml, String eventId) {

    }
}
